HDU 5747 Aaronson (lower_bound函数)

来源:互联网 发布:产品报价软件 编辑:程序博客网 时间:2024/05/18 02:06

Aaronson

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)
Total Submission(s): 613    Accepted Submission(s): 354


Problem Description
Recently, Peter saw the equation x0+2x1+4x2+...+2mxm=n. He wants to find a solution (x0,x1,x2,...,xm) in such a manner that i=0mxi is minimum and every xi (0im) is non-negative.
 

Input
There are multiple test cases. The first line of input contains an integerT(1T105), indicating the number of test cases. For each test case:

The first contains two integers n and m(0n,m109).
 

Output
For each test case, output the minimum value of i=0mxi.
 

Sample Input
101 23 25 210 210 310 413 520 411 1112 3
 

Sample Output
1223223232
 

Source
BestCoder Round #84
 

Recommend
wange2014   |   We have carefully selected several similar problems for you:  5751 5750 5749 5748 5746 

 思路: 注意m是非常大的

函数lower_bound()在first和last中的前闭后开区间进行二分查找,返回大于或等于val的第一个元素位置。如果所有元素都小于val,则返回last的位置

举例如下:

一个数组number序列为:4,10,11,30,69,70,96,100.设要插入数字3,9,111.pos为要插入的位置的下标

pos = lower_bound( number, number + 8, 3) - number,pos = 0.即number数组的下标为0的位置。

pos = lower_bound( number, number + 8, 9) - number, pos = 1,即number数组的下标为1的位置(即10所在的位置)。

pos = lower_bound( number, number + 8, 111) - number, pos = 8,即number数组的下标为8的位置(但下标上限为7,所以返回最后一个元素的下一个元素)。

所以,要记住:函数lower_bound()在first和last中的前闭后开区间进行二分查找,返回大于或等于val的第一个元素位置。如果所有元素都小于val,则返回last的位置,且last的位置是越界的!!~

返回查找元素的第一个可安插位置,也就是“元素值>=查找值”的第一个元素的位置

#include<cstdio>#include<cstring>#include<algorithm>using namespace std;int main(){int t,n,m,i,j,a[32];a[0]=1;for(i=1;i<31;i++){a[i]=a[i-1]*2;}scanf("%d",&t);while(t--){int ans=0;scanf("%d%d",&n,&m);int x=lower_bound(a,a+30,n)-a;for(i=min(x,m);i>=0;i--){ans+=(n/a[i]);n=n%a[i];if(n==0)break;}printf("%d\n",ans);}return 0;}



0 0
原创粉丝点击